summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorDaniel Baumann <daniel.baumann@open-infrastructure.net>2016-06-11 07:33:31 +0000
committerDaniel Baumann <daniel.baumann@open-infrastructure.net>2016-07-15 15:57:07 +0000
commit3d8c21d6d0d84cb28642df19d30801734a5d096e (patch)
treeaa756288daf105f771f8906804f84bb048fcb7e4
parentdebian: Adding divertions for uptime. (diff)
downloadcompute-tools-3d8c21d6d0d84cb28642df19d30801734a5d096e.tar.xz
compute-tools-3d8c21d6d0d84cb28642df19d30801734a5d096e.zip
Adding container-uptime program.
-rwxr-xr-xbin/container-uptime80
-rw-r--r--share/man/container-uptime.1.txt71
2 files changed, 151 insertions, 0 deletions
diff --git a/bin/container-uptime b/bin/container-uptime
new file mode 100755
index 0000000..82b79b6
--- /dev/null
+++ b/bin/container-uptime
@@ -0,0 +1,80 @@
+#!/bin/sh
+
+# container-tools - Manage systemd-nspawn containers
+# Copyright (C) 2014-2016 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+set -e
+
+if [ -e /usr/bin/uptime.orig.procps ]
+then
+ # debian
+ UPTIME="$(/usr/bin/uptime.orig.procps)"
+else
+ # standalone
+ UPTIME="$(/usr/bin/uptime)"
+fi
+
+DATE_HOST="$(date +%s)"
+
+DATE_CONTAINER="$(stat -c %z /dev/pts)"
+DATE_CONTAINER="$(date +%s -d"${DATE_CONTAINER}")"
+
+UPTIME_CONTAINER="$((${DATE_HOST} - ${DATE_CONTAINER}))"
+#UPTIME_CONTAINER=${1}
+
+if [ ${UPTIME_CONTAINER} -lt 3600 ]
+then
+ # container uptime << 1 hour
+ MINUTES="$(( ${UPTIME_CONTAINER} / 60 ))"
+
+ if [ "${MINUTES}" = "0" ]
+ then
+ MINUTES="1"
+ fi
+
+ UPTIME="$(echo "${UPTIME}" | sed -e "s| up .* days, .*:[0-9][0-9], | up ${MINUTES} min, |" \
+ -e "s| up .* day, .*:[0-9][0-9], | up ${MINUTES} min, |" \
+ -e "s| up .* min, | up ${MINUTES} min, |")"
+elif [ ${UPTIME_CONTAINER} -lt 86400 ]
+then
+ # container uptime << 1day
+ HOURS="$(( ${UPTIME_CONTAINER} / 3600 ))"
+ MINUTES="$(( (${UPTIME_CONTAINER} - (${HOURS} * 3600)) / 60 ))"
+
+ UPTIME="$(echo "${UPTIME}" | sed -e "s| up .* days, .*:[0-9][0-9], | up ${HOURS}:${MINUTES}, |" \
+ -e "s| up .* day, .*:[0-9][0-9], | up ${MINUTES} min, |")"
+elif [ "${UPTIME_CONTAINER}" -lt 172800 ]
+then
+ # container uptime << 2 days
+ DAYS="$(( ${UPTIME_CONTAINER} / 86400 ))"
+ HOURS="$(( (${UPTIME_CONTAINER} - (${DAYS} * 86400)) / 3600 ))"
+ MINUTES="$(( (${UPTIME_CONTAINER} - (${HOURS} * 3600)) / 60 ))"
+
+ UPTIME="$(echo "${UPTIME}" | sed -e "s| up .* days, .*:[0-9][0-9], | up ${HOURS}:${MINUTES}, |" \
+ -e "s| up .* day, .*:[0-9][0-9], | up ${MINUTES} min, |")"
+else
+ # container uptime >= 2 days
+ DAYS="$(( ${UPTIME_CONTAINER} / 86400 ))"
+ HOURS="$(( (${UPTIME_CONTAINER} - (${DAYS} * 86400)) / 3600 ))"
+ MINUTES="$(( (${UPTIME_CONTAINER} - (${HOURS} * 3600)) / 60 ))"
+
+ UPTIME="$(echo "${UPTIME}" | sed -e "s| up .* days, .*:[0-9][0-9], | up ${HOURS}:${MINUTES}, |")"
+fi
+
+echo D: ${UPTIME_CONTAINER}
+echo D: ${DAYS} days ${HOURS}:${MINUTES}
+
+echo "${UPTIME}"
diff --git a/share/man/container-uptime.1.txt b/share/man/container-uptime.1.txt
new file mode 100644
index 0000000..a4ef141
--- /dev/null
+++ b/share/man/container-uptime.1.txt
@@ -0,0 +1,71 @@
+// container-tools - Manage systemd-nspawn containers
+// Copyright (C) 2014-2016 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+//
+// This program is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+CONTAINER-UPTIME(1)
+====================
+:doctype: manpage
+:man manual: Open Infrastructure
+:man source: container-tools
+:man version: {revnumber}
+
+
+NAME
+----
+container-uptime - Tell how long the system has been running (works with container)
+
+
+SYNOPSIS
+--------
+*container-uptime* ['OPTIONS']
+
+
+DESCRIPTION
+-----------
+container-uptime is a wrapper replacing the uptime command provided by the procps package.
+
+container-uptime displays the correct uptime when a system is being used in a Linux Container, where the original uptime command shows the host uptime for all containers. container-uptime passes through all command-line arguments to the original uptime command; see \fIuptime.orig.procps\fR(1) for more information about the options of the original uptime command.
+
+
+OPTIONS
+-------
+This command has no options.
+
+
+EXAMPLES
+--------
+*Show system uptime:*::
+ container-uptime
+
+
+SEE ALSO
+--------
+container-tools(7),
+container(1).
+
+
+HOMEPAGE
+--------
+More information about container-tools and the Open Infrastructure project can be found on the homepage at https://open-infrastructure.net.
+
+
+BUGS
+----
+Bugs can be reported by opening an issue in the GitHub repository at https://github.com/open-infrastructure/container-tools.
+
+
+AUTHORS
+-------
+container-tools was written by Daniel Baumann <daniel.baumann@open-infrastructure.net>.